﻿package {
	import flash.display.Stage;
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.geom.Rectangle;
	
	public class ScrollMovieClip extends MovieClip {
		private var host_mc:MovieClip;
		private var call_back:Function;
		
		private var drag_mc:MovieClip;
		private var track_mc:MovieClip;
		
		private var scroll_rect:Rectangle;
		
		public function ScrollMovieClip( _mc:MovieClip, max_height:Number, cb:Function ) {
			host_mc = _mc;
			call_back = cb;
			
			var sc:MovieClip = new MovieClip();
			addChild(sc);
			
			track_mc = new Track();
			track_mc.height = max_height;
			sc.addChild(track_mc);
			track_mc.buttonMode = true;
			track_mc.mouseChildren = false;
			track_mc.addEventListener( MouseEvent.CLICK, click_track );
			drag_mc = new Dragger();
			sc.addChild(drag_mc);
			drag_mc.buttonMode = true;
			drag_mc.mouseChildren = false;
			drag_mc.addEventListener( MouseEvent.MOUSE_DOWN, press_drag );
			
			scroll_rect = new Rectangle( track_mc.x, track_mc.y, 0, track_mc.height - drag_mc.height );
			
		}
		
		private function press_drag( event:MouseEvent ):void {
			/***************************************************/
			drag_mc.stage.addEventListener( MouseEvent.MOUSE_UP, release_drag, false, 0, true );
			/***************************************************/ 
			drag_mc.startDrag( false, scroll_rect );
			drag_mc.addEventListener( Event.ENTER_FRAME, drag );
		}
		
		private function release_drag( event:MouseEvent ):void {
			drag_mc.removeEventListener( Event.ENTER_FRAME, drag );
			drag_mc.stage.removeEventListener( MouseEvent.MOUSE_UP, release_drag );
			drag_mc.stopDrag();
		}
		
		private function click_track( event:MouseEvent ):void {
			//trace( "Click track" );
		}
		
		
		private function drag( event:Event ):void {
			call_back( drag_mc.y, drag_mc.height);
		}
	}
}

